#!/usr/bin/python
##### Enakomerna skupina 8 izvorov - S53MV 13.2.2018 #####

import math,numpy	#uporabljene funkcije

def smerni(m,kh,fi,t):	#smerni diagram enakomerne skupine
	return abs(math.sin(m*(fi+kh*math.cos(t))/2)/math.sin((fi+kh*math.cos(t))/2))/m

xk=[]		#polja za risanje kroga
yk=[]
x1=[]		#polja za risanje funkcije
y1=[]
x2=[]
y2=[]

k=0.01		#korak risanja v radianih
m=8		#stevilo elementov skupine

kh1=math.pi	#enakomerna skupina h=0.5*lambda, fi=0
fi1=0
kh2=math.pi	#enakomerna skupina h=0.5*lambda, fi=30stopinj
fi2=30*math.pi/180

t=-math.pi+k/2		#kot theta v radianih
while t<math.pi:
	xk=xk+[math.sin(t)]	#referencni enotni krog
	yk=yk+[math.cos(t)]
	x1=x1+[math.sin(t)*smerni(m,kh1,fi1,t)]	#skupina #1
	y1=y1+[math.cos(t)*smerni(m,kh1,fi1,t)]
	x2=x2+[math.sin(t)*smerni(m,kh2,fi2,t)]	#skupina #2
	y2=y2+[math.cos(t)*smerni(m,kh2,fi2,t)]
	t=t+k			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(xk,yk,'g-')		#referencni enotni krog
plt.plot([-1,1],[0,0],'g-')	#koordinatne osi
plt.plot([0,0],[-1,1],'g-')
plt.plot(x1,y1,'b-')		#risanje funkcij
plt.plot(x2,y2,'r-')
plt.axis([-1.05,1.05,-1.05,1.05]) #okvir
plt.xticks([])
plt.yticks([])
plt.xlabel('Os z')
plt.ylabel('Ravnina xy')
plt.axes().set_aspect('equal')
plt.show()

#konec programa

