#!/usr/bin/python
##### Smerni diagram nesmiselne skupine Huygensovih izvorov - S53MV 18.2.2018 #####

import math,cmath	#uporabljene funkcije

k=0.001		#korak risanja v radianih

h=10*math.pi	#razmak interferometra h=10lambda
e=math.pi/2	#odklon anten od ravnine xy
n=1/(math.cos(e)+1)	#normalizacija vsote

xk=[]		#polja za risanje kroga
yk=[]
x1=[]		#polja za risanje funkcij
y1=[]
x2=[]
y2=[]
x3=[]
y3=[]

t=-math.pi		#kot theta v radianih
while t<=math.pi:
	xk=xk+[math.sin(t)]	#referencni enotni krog
	yk=yk+[math.cos(t)]
	f1=(1+math.cos(t-math.pi/2+e))/2	#Huygens #1
	x1=x1+[math.sin(t)*f1]
	y1=y1+[math.cos(t)*f1]
	f2=(1+math.cos(t-math.pi/2-e))/2	#Huygens #2
	x2=x2+[math.sin(t)*f2]
	y2=y2+[math.cos(t)*f2]
	f=h*math.cos(t)				#nesmiselna skupina
	f3=abs(f1*cmath.exp(complex(0,f))-f2*cmath.exp(complex(0,-f)))*n
	x3=x3+[math.sin(t)*f3]
	y3=y3+[math.cos(t)*f3]
	t=t+k			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(xk,yk,'k-')		#referencni enotni krog
plt.plot([-1,1],[0,0],'k-')	#koordinatne osi
plt.plot([0,0],[-1,1],'k-')
plt.plot(x1,y1,'b-')		#risanje funkcij
plt.plot(x2,y2,'g-')
plt.plot(x3,y3,'r-')
plt.axis([-1.05,1.05,-1.05,1.05])
plt.xticks([])
plt.yticks([])
plt.title('Linearno radialno merilo')
plt.xlabel('Os z')
plt.ylabel('Ravnina xy')
plt.axes().set_aspect('equal')
plt.show()

#konec programa

